From 60d65e22d3461b56aff09b6c4254d7161f2bc9ff Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Mon, 19 Aug 2019 19:20:42 -0400
Subject: [PATCH 18/31] added a refactored squad joining entrypoint; initial
 work and test on SquadWaypointEvent packet; initial work on
 SquadWaypointRequest packet; squad waypoints up to #5 (squad experience)
 should be working

---
 .../psforever/packet/GamePacketOpcode.scala   |   2 +-
 .../packet/game/SquadWaypointEvent.scala      |  74 +++---
 .../packet/game/SquadWaypointRequest.scala    | 115 +++++++++
 .../scala/services/teamwork/SquadAction.scala |   4 +-
 .../services/teamwork/SquadResponse.scala     |   3 +
 .../services/teamwork/SquadService.scala      | 233 +++++++++++-------
 .../scala/game/SquadWaypointEventTest.scala   |  34 +--
 .../src/main/scala/WorldSessionActor.scala    |  25 +-
 8 files changed, 343 insertions(+), 147 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/packet/game/SquadWaypointRequest.scala

diff --git a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
index 54452c55..2d10e152 100644
--- a/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
+++ b/common/src/main/scala/net/psforever/packet/GamePacketOpcode.scala
@@ -472,7 +472,7 @@ object GamePacketOpcode extends Enumeration {
     case 0x80 => noDecoder(GenericObjectAction2Message)
     case 0x81 => game.DestroyDisplayMessage.decode
     case 0x82 => noDecoder(TriggerBotAction)
-    case 0x83 => noDecoder(SquadWaypointRequest)
+    case 0x83 => game.SquadWaypointRequest.decode
     case 0x84 => game.SquadWaypointEvent.decode
     case 0x85 => noDecoder(OffshoreVehicleMessage)
     case 0x86 => game.ObjectDeployedMessage.decode
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadWaypointEvent.scala b/common/src/main/scala/net/psforever/packet/game/SquadWaypointEvent.scala
index 3874b625..4fe9f649 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadWaypointEvent.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadWaypointEvent.scala
@@ -7,16 +7,16 @@ import scodec.{Attempt, Codec, Err}
 import scodec.codecs._
 import shapeless.{::, HNil}
 
-final case class WaypointEvent(unk1 : Int,
+final case class WaypointEvent(zone_number : Int,
                                pos : Vector3,
-                               unk2 : Int)
+                               unk : Int)
 
-final case class SquadWaypointEvent(unk1 : Int,
-                                    unk2 : Int,
-                                    unk3 : Long,
-                                    unk4 : Int,
+final case class SquadWaypointEvent(event_type : WaypointEventAction.Value,
+                                    unk : Int,
+                                    char_id : Long,
+                                    waypoint_type : Int,
                                     unk5 : Option[Long],
-                                    unk6 : Option[WaypointEvent])
+                                    waypoint_info : Option[WaypointEvent])
   extends PlanetSideGamePacket {
   type Packet = SquadWaypointEvent
   def opcode = GamePacketOpcode.SquadWaypointEvent
@@ -24,55 +24,55 @@ final case class SquadWaypointEvent(unk1 : Int,
 }
 
 object SquadWaypointEvent extends Marshallable[SquadWaypointEvent] {
-  def apply(unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Int, unk_a : Long) : SquadWaypointEvent =
-    SquadWaypointEvent(unk1, unk2, unk3, unk4, Some(unk_a), None)
+  def Add(unk : Int, char_id : Long, waypoint_type : Int, waypoint : WaypointEvent) : SquadWaypointEvent =
+    SquadWaypointEvent(WaypointEventAction.Add, unk, char_id, waypoint_type, None, Some(waypoint))
 
-  def apply(unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Int, unk_a : Int, pos : Vector3, unk_b : Int) : SquadWaypointEvent =
-    SquadWaypointEvent(unk1, unk2, unk3, unk4, None, Some(WaypointEvent(unk_a, pos, unk_b)))
+  def Unknown1(unk : Int, char_id : Long, waypoint_type : Int, unk_a : Long) : SquadWaypointEvent =
+    SquadWaypointEvent(WaypointEventAction.Unknown1, unk, char_id, waypoint_type, Some(unk_a), None)
 
-  def apply(unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Int) : SquadWaypointEvent =
-    SquadWaypointEvent(unk1, unk2, unk3, unk4, None, None)
+  def Remove(unk : Int, char_id : Long, waypoint_type : Int) : SquadWaypointEvent =
+    SquadWaypointEvent(WaypointEventAction.Remove, unk, char_id, waypoint_type, None, None)
 
   private val waypoint_codec : Codec[WaypointEvent] = (
-    ("unk1" | uint16L) ::
+    ("zone_number" | uint16L) ::
       ("pos" | Vector3.codec_pos) ::
-      ("unk2" | uint(3))
+      ("unk" | uint(3))
     ).as[WaypointEvent]
 
   implicit val codec : Codec[SquadWaypointEvent] = (
-    ("unk1" | uint2) >>:~ { unk1 =>
-      ("unk2" | uint16L) ::
-      ("unk3" | uint32L) ::
-        ("unk4" | uint8L) ::
-        ("unk5" | conditional(unk1 == 1, uint32L)) ::
-        ("unk6" | conditional(unk1 == 0, waypoint_codec))
+    ("event_type" | WaypointEventAction.codec) >>:~ { event_type =>
+      ("unk" | uint16L) ::
+      ("char_id" | uint32L) ::
+        ("waypoint_type" | uint8L) ::
+        ("unk5" | conditional(event_type == WaypointEventAction.Unknown1, uint32L)) ::
+        ("waypoint_info" | conditional(event_type == WaypointEventAction.Add, waypoint_codec))
     }
   ).exmap[SquadWaypointEvent] (
     {
-      case 0 :: a :: b :: c :: None :: Some(d) :: HNil =>
-        Attempt.Successful(SquadWaypointEvent(0, a, b, c, None, Some(d)))
+      case WaypointEventAction.Add :: a :: char_id :: waypoint_type :: None :: Some(waypoint) :: HNil =>
+        Attempt.Successful(SquadWaypointEvent(WaypointEventAction.Add, a, char_id, waypoint_type, None, Some(waypoint)))
 
-      case 1 :: a :: b :: c :: Some(d) :: None :: HNil =>
-        Attempt.Successful(SquadWaypointEvent(1, a, b, c, Some(d), None))
+      case WaypointEventAction.Unknown1 :: a :: char_id :: waypoint_type :: Some(d) :: None :: HNil =>
+        Attempt.Successful(SquadWaypointEvent(WaypointEventAction.Unknown1, a, char_id, waypoint_type, Some(d), None))
 
-      case a :: b :: c :: d :: None :: None :: HNil =>
-        Attempt.Successful(SquadWaypointEvent(a, b, c, d, None, None))
+      case event_type :: b :: char_id :: waypoint_type :: None :: None :: HNil =>
+        Attempt.Successful(SquadWaypointEvent(event_type, b, char_id, waypoint_type, None, None))
 
-      case n :: _ :: _ :: _ :: _ :: _ :: HNil =>
-        Attempt.Failure(Err(s"unexpected format for unk1 - $n"))
+      case data =>
+        Attempt.Failure(Err(s"unexpected format for $data"))
     },
     {
-      case SquadWaypointEvent(0, a, b, c, None, Some(d)) =>
-        Attempt.Successful(0 :: a :: b :: c :: None :: Some(d) :: HNil)
+      case SquadWaypointEvent(WaypointEventAction.Add, a, char_id, waypoint_type, None, Some(waypoint)) =>
+        Attempt.Successful(WaypointEventAction.Add :: a :: char_id :: waypoint_type :: None :: Some(waypoint) :: HNil)
 
-      case SquadWaypointEvent(1, a, b, c, Some(d), None) =>
-        Attempt.Successful(1 :: a :: b :: c :: Some(d) :: None :: HNil)
+      case SquadWaypointEvent(WaypointEventAction.Unknown1, a, char_id, waypoint_type, Some(d), None) =>
+        Attempt.Successful(WaypointEventAction.Unknown1 :: a :: char_id :: waypoint_type :: Some(d) :: None :: HNil)
 
-      case SquadWaypointEvent(a, b, c, d, None, None) =>
-        Attempt.Successful(a :: b :: c :: d :: None :: None :: HNil)
+      case SquadWaypointEvent(event_type, b, char_id, waypoint_type, None, None) =>
+        Attempt.Successful(event_type :: b :: char_id :: waypoint_type :: None :: None :: HNil)
 
-      case SquadWaypointEvent(n, _, _, _, _, _) =>
-        Attempt.Failure(Err(s"unexpected format for unk1 - $n"))
+      case data =>
+        Attempt.Failure(Err(s"unexpected format for $data"))
     }
   )
 }
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadWaypointRequest.scala b/common/src/main/scala/net/psforever/packet/game/SquadWaypointRequest.scala
new file mode 100644
index 00000000..5b7ebd57
--- /dev/null
+++ b/common/src/main/scala/net/psforever/packet/game/SquadWaypointRequest.scala
@@ -0,0 +1,115 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.packet.game
+
+import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
+import net.psforever.types.Vector3
+import scodec.{Attempt, Codec, Err}
+import scodec.codecs._
+import shapeless.{::, HNil}
+
+/**
+  * Actions that can be requested of the specific waypoint.
+  */
+object WaypointEventAction extends Enumeration {
+  type Type = Value
+
+  val
+  Add,
+  Unknown1,
+  Remove,
+  Unknown3 //unconfirmed
+  = Value
+
+  implicit val codec : Codec[WaypointEventAction.Value] = PacketHelpers.createEnumerationCodec(enum = this, uint2)
+}
+
+/**
+  * na
+  * @param zone_number the zone
+  * @param pos the continental map coordinate location of the waypoint;
+  *            the z-coordinate is almost always 0.0
+  */
+final case class WaypointInfo(zone_number : Int,
+                              pos : Vector3)
+
+/**
+  * na
+  * @param request_type the action to be performed
+  * @param char_id the unique id of player setting the waypoint
+  * @param waypoint_type the waypoint being updated;
+  *                      0-3 for the standard squad waypoints numbered "1-4";
+  *                      4 for the squad leader experience waypoint;
+  *                      cycles through 0-3 continuously
+  *
+  * @param unk4 na
+  * @param waypoint_info essential data about the waypoint
+  */
+final case class SquadWaypointRequest(request_type : WaypointEventAction.Value,
+                                      char_id : Long,
+                                      waypoint_type : Int,
+                                      unk4 : Option[Long],
+                                      waypoint_info : Option[WaypointInfo])
+  extends PlanetSideGamePacket {
+  type Packet = SquadWaypointRequest
+  def opcode = GamePacketOpcode.SquadWaypointRequest
+  def encode = SquadWaypointRequest.encode(this)
+}
+
+object SquadWaypointRequest extends Marshallable[SquadWaypointRequest] {
+  def Add(char_id : Long, waypoint_type : Int, waypoint : WaypointInfo) : SquadWaypointRequest =
+    SquadWaypointRequest(WaypointEventAction.Add, char_id, waypoint_type, None, Some(waypoint))
+
+  def Unknown1(char_id : Long, waypoint_type : Int, unk_a : Long) : SquadWaypointRequest =
+    SquadWaypointRequest(WaypointEventAction.Unknown1, char_id, waypoint_type, Some(unk_a), None)
+
+  def Remove(char_id : Long, waypoint_type : Int) : SquadWaypointRequest =
+    SquadWaypointRequest(WaypointEventAction.Remove, char_id, waypoint_type, None, None)
+
+  private val waypoint_codec : Codec[WaypointInfo] = (
+    ("zone_number" | uint16L) ::
+      ("pos" | Vector3.codec_pos)
+    ).xmap[WaypointInfo] (
+    {
+      case zone_number :: pos :: HNil => WaypointInfo(zone_number, pos)
+    },
+    {
+      case WaypointInfo(zone_number, pos) => zone_number :: pos.xy :: HNil
+    }
+  )
+
+  implicit val codec : Codec[SquadWaypointRequest] = (
+    ("request_type" | WaypointEventAction.codec) >>:~ { request_type =>
+      ("char_id" | uint32L) ::
+        ("waypoint_type" | uint8L) ::
+        ("unk4" | conditional(request_type == WaypointEventAction.Unknown1, uint32L)) ::
+        ("waypoint" | conditional(request_type == WaypointEventAction.Add, waypoint_codec))
+    }
+    ).exmap[SquadWaypointRequest] (
+    {
+      case WaypointEventAction.Add :: char_id :: waypoint_type :: None :: Some(waypoint) :: HNil =>
+        Attempt.Successful(SquadWaypointRequest(WaypointEventAction.Add, char_id, waypoint_type, None, Some(waypoint)))
+
+      case WaypointEventAction.Unknown1 :: char_id :: waypoint_type :: Some(d) :: None :: HNil =>
+        Attempt.Successful(SquadWaypointRequest(WaypointEventAction.Unknown1, char_id, waypoint_type, Some(d), None))
+
+      case request_type :: char_id :: waypoint_type :: None :: None :: HNil =>
+        Attempt.Successful(SquadWaypointRequest(request_type, char_id, waypoint_type, None, None))
+
+      case data =>
+        Attempt.Failure(Err(s"unexpected format while decoding - $data"))
+    },
+    {
+      case SquadWaypointRequest(WaypointEventAction.Add, char_id, waypoint_type, None, Some(waypoint)) =>
+        Attempt.Successful(WaypointEventAction.Add :: char_id :: waypoint_type :: None :: Some(waypoint) :: HNil)
+
+      case SquadWaypointRequest(WaypointEventAction.Unknown1, char_id, waypoint_type, Some(d), None) =>
+        Attempt.Successful(WaypointEventAction.Unknown1 :: char_id :: waypoint_type :: Some(d) :: None :: HNil)
+
+      case SquadWaypointRequest(request_type, char_id, waypoint_type, None, None) =>
+        Attempt.Successful(request_type :: char_id :: waypoint_type :: None :: None :: HNil)
+
+      case data : SquadWaypointRequest =>
+        Attempt.Failure(Err(s"unexpected format while encoding - $data"))
+    }
+  )
+}
diff --git a/common/src/main/scala/services/teamwork/SquadAction.scala b/common/src/main/scala/services/teamwork/SquadAction.scala
index 62e3f2fe..d5da028e 100644
--- a/common/src/main/scala/services/teamwork/SquadAction.scala
+++ b/common/src/main/scala/services/teamwork/SquadAction.scala
@@ -1,7 +1,6 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import net.psforever.objects.Player
 import net.psforever.objects.zones.Zone
 import net.psforever.packet.game._
 import net.psforever.types.{SquadRequestType, Vector3}
@@ -9,7 +8,8 @@ import net.psforever.types.{SquadRequestType, Vector3}
 object SquadAction {
   trait Action
 
-  final case class Definition(player : Player, zone : Zone, guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
+  final case class Definition(zone : Zone, guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
   final case class Membership(request_type : SquadRequestType.Value, unk2 : Long, unk3 : Option[Long], player_name : String, unk5 : Option[Option[String]]) extends Action
+  final case class Waypoint(event_type : WaypointEventAction.Value, waypoint_type : Int, unk : Option[Long], waypoint_info : Option[WaypointInfo]) extends Action
   final case class Update(char_id : Long, health : Int, max_health : Int, armor : Int, max_armor : Int, pos : Vector3, zone_number : Int) extends Action
 }
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index fa06d866..817d27e5 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -29,5 +29,8 @@ object SquadResponse {
 
   final case class Detail(guid : PlanetSideGUID, squad_detail : SquadDetail) extends Response
 
+  final case class InitWaypoints(char_id : Long, waypoints : Iterable[(Int, WaypointInfo, Int)]) extends Response
+  final case class WaypointEvent(event_type : WaypointEventAction.Value, char_id : Long, waypoint_type : Int, unk5 : Option[Long], waypoint_info : Option[WaypointInfo], unk : Int) extends Response
+
   final case class SquadSearchResults() extends Response
 }
